#include "node_aruco/tools/GenerateTags.h"

GenerateTags::GenerateTags()
{
  pxcm =10; //Pixles pr cm
  psice = 90; //Pad size in cm
  margin = 3; // in cm
  
  dictionary = cv::aruco::getPredefinedDictionary(cv::aruco::DICT_5X5_50);	//Dictionary
}

cv::Mat GenerateTags::Marker_5x5x4(int tagNr)
{
    double arucoDim [4];
  
    arucoDim[0]=pxcm*psice*3/4-2*margin*pxcm;
    arucoDim[1]=pxcm*psice*1/4-margin*pxcm;
    arucoDim[2]=pxcm*psice*1/8;
    arucoDim[3]=pxcm*psice*1/16;
    
    //Create empty image
    cv::Mat fullTag(pxcm*psice, pxcm*psice, CV_8UC1, cv::Scalar(255,255,255));
    
    //Create marker images
    cv::Mat markerImage[4];
    
    for(int i= 0;i<4;i=i+1){
      cv::aruco::drawMarker(dictionary,tagNr+i,arucoDim[i], markerImage[i], 1);
    }
    
    //Fill the empty image with marker images
    
    markerImage[0].copyTo(fullTag(cv::Rect(margin*pxcm,margin*pxcm,markerImage[0].cols,markerImage[0].rows)));
    markerImage[1].copyTo(fullTag(cv::Rect(2*margin*pxcm+arucoDim[0],margin*pxcm+arucoDim[0]-arucoDim[1],markerImage[1].cols,markerImage[1].rows)));
    markerImage[2].copyTo(fullTag(cv::Rect(2*margin*pxcm+arucoDim[0],2*margin*pxcm+arucoDim[0],markerImage[2].cols,markerImage[2].rows)));
    markerImage[3].copyTo(fullTag(cv::Rect(margin*pxcm+arucoDim[0]-arucoDim[3],margin*pxcm*2+arucoDim[0],markerImage[3].cols,markerImage[3].rows)));
    
    return fullTag;
    //cv::imwrite("marker_5x5x4.jpg", fullTag);
}

cv::Mat GenerateTags::Marker_5x5x2(int tagNr)
{
  
    double arucoDim [2];
  
    arucoDim[0]=pxcm*psice;
    arucoDim[1]=pxcm*psice/7;

    
    cv::Mat fullTag(pxcm*psice, pxcm*psice, CV_8UC1, cv::Scalar(255,255,255));
    
    //Create marker images
    cv::Mat markerImage[2];
    
    for(int i= 0;i<2;i++){
      cv::aruco::drawMarker(dictionary,tagNr+i,arucoDim[i], markerImage[i], 1);
    }
    
    //Fill the empty image with marker images
    markerImage[0].copyTo(fullTag(cv::Rect(0,0,markerImage[0].cols,markerImage[0].rows)));
    markerImage[1].copyTo(fullTag(cv::Rect(arucoDim[1]*3,arucoDim[1]*3,markerImage[1].cols,markerImage[1].rows)));
    
    return fullTag;
}

// void GenerateTags::SaveToFile()
// {
//   //cv::imshow("aruco", fullTag);
//   return 0;
// }

//camera calibration i ros

// catkin_make
//./devel/lib/aruco_project/aruco_project_node

//To inclide in main

//GenerateTags gt;

//cv::imshow("aruco", gt.Marker_5x5x2(35));
//cv::imshow("aruco", gt.Marker_5x5x4(0));
//cv::waitKey(0);

//return 0;