//
// Created by Line on 01.05.18.
//

#ifndef PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H
#define PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H

#include <node_msgs/navResults.h>
#include <node_msgs/cmd_status.h>
#include <eigen3/Eigen/Dense>

class NavigationCallback{
public:
    struct states{
        Eigen::Vector3d rel_position;
        Eigen::Matrix3d rel_position_covariance;
        Eigen::Vector3d lp_vel;
        Eigen::Matrix3d lp_vel_covariance;
        Eigen::Vector3d gnss_bias;
        Eigen::Matrix3d gnss_bias_covariance;
    };

    struct status{
        bool controlGiven;
        double V_max;
        double V_max_decent;
    };

    NavigationCallback();
    void statesCallback(const node_msgs::navResults::Ptr& states);
    void cmdStatusCallback(const node_msgs::cmd_status::Ptr& status);

    states getStates();
    status getStatus();
private:
    states states_;
    status status_;
};


#endif //PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H
