//
// Created by line on 01.05.18.
//

#include "node_controller/tools/navigationCallback.h"

NavigationCallback::NavigationCallback() {
    status_={false,0.0,0.0};
    Eigen::Vector3d vec0 = Eigen::Vector3d::Zero();
    Eigen::Matrix3d mat0 = Eigen::Matrix3d::Zero();
    states_={vec0,mat0,vec0,mat0,vec0,mat0};
}

void NavigationCallback::statesCallback(const node_msgs::navResults::Ptr &st) {
    states_.rel_position = Eigen::Map<Eigen::Vector3d>(st->relative_pos.elems);
    states_.rel_position_covariance = Eigen::Map<Eigen::Matrix3d>(st->relative_pos_covar.elems);

    states_.lp_vel= Eigen::Map<Eigen::Vector3d>(st->vel_LP.elems);
    states_.lp_vel_covariance=Eigen::Map<Eigen::Matrix3d>(st->vel_LP_covar.elems);

    states_.gnss_bias=Eigen::Map<Eigen::Vector3d>(st->bias_gnss.elems);
    states_.gnss_bias_covariance=Eigen::Map<Eigen::Matrix3d>(st->bias_gnss_covar.elems);
}

void NavigationCallback::cmdStatusCallback(const node_msgs::cmd_status::Ptr &stat) {
    status_.controlGiven=stat->control_given;
    status_.V_max=stat->V_max;
    status_.V_max_decent=stat->V_max_decent;
}

NavigationCallback::states NavigationCallback::getStates() {
    return states_;
}

NavigationCallback::status NavigationCallback::getStatus() {
    return status_;
}