//
// Created by line on 14.02.18.
//

#ifndef PROJECT_COORDINATEFRAMES_H
#define PROJECT_COORDINATEFRAMES_H

#include <eigen3/Eigen/Dense>
#include <cmath>

#define r2d M_PI/180

class CoordinateFrames {
public:
    struct geodetic{
        double latitude;
        double longitude;
        double altitude;
    };

    CoordinateFrames();
    CoordinateFrames(const geodetic& ned);

    Eigen::Vector3d getVectNED2geodetic(const geodetic& point);
    geodetic getNED(){return NED;};
    geodetic setNED(const geodetic& ned){NED=ned;NEDdefined=true;return NED;};

    bool isNedDefined(){return NEDdefined;};

    static Eigen::Vector3d geodetic2ECEF(const geodetic& geo);
    static Eigen::Vector3d geodetic2vect(const geodetic& refPont, const geodetic& destPoint);
    static Eigen::Vector3d ENU2NED_euler(const Eigen::Vector3d& inVectEul);
    static Eigen::Quaterniond ENU2NED_quat(const Eigen::Quaterniond& quat_ENU);


private:
    //NED
    geodetic NED;
    bool NEDdefined;

    // Earth constants (WGS84)
    //Semi-major axis
    //static const double R_Ea = 6378137.0;     //m
    //Flattering factor
    //static const double f = 1/298.257223563;
    //Semi minor axis
    //static const double R_Eb = R_Ea*(1-f);    //m
    //First eccentricity
    //static const double e = std::sqrt(std::pow(R_Ea,2.0)-std::pow(R_Eb,2.0))/R_Ea;
};

#endif //PROJECT_COORDINATEFRAMES_H
