//
// Created by Line on 01.05.18.
//

#ifndef PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H
#define PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H

#include <node_msgs/navResults.h>
#include <node_msgs/cmd_status.h>
#include <eigen3/Eigen/Dense>
#include <iostream>
#include <fstream>
#include <ros/time.h>
#include "writeToFile.h"
#include <node_msgs/cmd_velocity.h>

class NavigationCallback{
public:
    struct states{
        Eigen::Vector3d rel_position;
        Eigen::Matrix3d rel_position_covariance;
        Eigen::Vector3d lp_vel;
        Eigen::Matrix3d lp_vel_covariance;
        Eigen::Vector3d gnss_bias;
        Eigen::Matrix3d gnss_bias_covariance;
    };

    NavigationCallback();
    void statesCallback(const node_msgs::navResults::Ptr& states);
    void smCallback(const node_msgs::cmd_velocity::Ptr& sm);

private:
    states states_;

    WriteToFile wf;
    WriteToFile wf2;
    std::ofstream myfile;
    std::ofstream myfile2;

    ros::Time time_now;
};


#endif //PROJECT_CONTROLLER_NAVIGATIONCALLBACK_H
