//
// Created by line on 01.05.18.
//

#include "node_navigation/tools/navigationCallback.h"

NavigationCallback::NavigationCallback() {
    Eigen::Vector3d vec0 = Eigen::Vector3d::Zero();
    Eigen::Matrix3d mat0 = Eigen::Matrix3d::Zero();
    states_={vec0,mat0,vec0,mat0,vec0,mat0};

    myfile.open("KfStates.csv");
    myfile2.open("StateMachine.csv");
    wf.writeHeader(myfile,"KF_Time;KF_States;KF_Covariance");
    wf2.writeHeader(myfile2,"SM_Time;Status");

}

void NavigationCallback::statesCallback(const node_msgs::navResults::Ptr &st) {
    states_.rel_position = Eigen::Map<Eigen::Vector3d>(st->relative_pos.elems);
    states_.rel_position_covariance = Eigen::Map<Eigen::Matrix3d>(st->relative_pos_covar.elems);

    states_.lp_vel= Eigen::Map<Eigen::Vector3d>(st->vel_LP.elems);
    states_.lp_vel_covariance=Eigen::Map<Eigen::Matrix3d>(st->vel_LP_covar.elems);

    states_.gnss_bias=Eigen::Map<Eigen::Vector3d>(st->bias_gnss.elems);
    states_.gnss_bias_covariance=Eigen::Map<Eigen::Matrix3d>(st->bias_gnss_covar.elems);

    time_now = ros::Time::now();
    Eigen::Matrix<double,9,1> estStates;
    estStates << states_.rel_position , states_.lp_vel , states_.gnss_bias;
    Eigen::Matrix<double,9,1> estCovar;
    estCovar << states_.rel_position_covariance.diagonal() , states_.lp_vel_covariance.diagonal() , states_.gnss_bias_covariance.diagonal();

    std::list<Eigen::MatrixXd> data = {estStates, estCovar};
    wf.writeDataToFile(myfile,time_now,data);
}

void NavigationCallback::smCallback(const node_msgs::cmd_velocity::Ptr &sm) {
    Eigen::Matrix<double,1,1> state;
    state(0,0) = double(sm->status);

    time_now = ros::Time::now();
    std::list<Eigen::MatrixXd> data = {state};

    wf2.writeDataToFile(myfile2,time_now,data);
}

